import { PRODUCT_FAMILY } from '@app/core/constants/product.constants';
import { DEFAULT_FAMILY } from '@app/core/i18n/constants/translate.constants';
import {
  TableFamilyConfig,
  TableHeader,
} from '@app/presentation/layout/mo-tables/interfaces/table.interface';
import { TABLE_MERCHANT_GROUP_MERCHANTS_BNPL } from './tables-bnpl/merchant-groups.table';
import {
  TABLE_MERCHANTS_BNPL,
  TABLE_MERCHANT_PROFILE_MOVEMENTS_BNPL,
  TABLE_MERCHANT_PROFILE_PURCHASES_BNPL,
} from './tables-bnpl/merchants.table';
import { TABLE_MOVEMENTS_BNPL } from './tables-bnpl/movements.table';
import { TABLE_PAYOUTS_BNPL } from './tables-bnpl/payouts.table';
import { TABLE_PURCHASES_BNPL } from './tables-bnpl/purchases.table';
import { TABLE_MERCHANT_GROUP_MERCHANTS_CREDIT_CARD } from './tables-credit-card/merchant-groups.table';
import {
  TABLE_MERCHANTS_CREDIT_CARD,
  TABLE_MERCHANT_PROFILE_MOVEMENTS_CREDIT_CARD,
  TABLE_MERCHANT_PROFILE_PURCHASES_CREDIT_CARD,
} from './tables-credit-card/merchants.table';
import { TABLE_MOVEMENTS_CREDIT_CARD } from './tables-credit-card/movements.table';
import { TABLE_PAYOUTS_CREDIT_CARD } from './tables-credit-card/payouts.table';
import { TABLE_PURCHASES_CREDIT_CARD } from './tables-credit-card/purchases.table';
import { TABLE_MERCHANT_GROUP_MERCHANTS_DEFAULT } from './tables-default/merchant-groups.table';
import {
  TABLE_MERCHANTS_DEFAULT,
  TABLE_MERCHANT_PROFILE_MOVEMENTS_DEFAULT,
  TABLE_MERCHANT_PROFILE_PURCHASES_DEFAULT,
} from './tables-default/merchants.table';
import { TABLE_MOVEMENTS_DEFAULT } from './tables-default/movements.table';
import { TABLE_PAYOUTS_DEFAULT } from './tables-default/payouts.table';
import { TABLE_PURCHASES_DEFAULT } from './tables-default/purchases.table';
import { TABLE_MERCHANT_GROUP_MERCHANTS_MCA } from './tables-mca/merchant-groups.table';
import {
  TABLE_MERCHANTS_MCA,
  TABLE_MERCHANT_PROFILE_MOVEMENTS_MCA,
  TABLE_MERCHANT_PROFILE_PURCHASES_MCA,
} from './tables-mca/merchants.table';
import { TABLE_MOVEMENTS_MCA } from './tables-mca/movements.table';
import { TABLE_PAYOUTS_MCA } from './tables-mca/payouts.table';
import { TABLE_PURCHASES_MCA } from './tables-mca/purchases.table';
import { TABLE_MERCHANT_LIST_NEW_GROUP_MERCHANTS_MICRO_CREDIT } from './tables-micro-credit/merchant-groups.table';
import {
  TABLE_MERCHANTS_MICRO_CREDIT,
  TABLE_MERCHANT_PROFILE_MOVEMENTS_MICRO_CREDIT,
  TABLE_MERCHANT_PROFILE_PURCHASES_MICRO_CREDIT,
} from './tables-micro-credit/merchants.table';
import { TABLE_MOVEMENTS_MICRO_CREDIT } from './tables-micro-credit/movements.table';
import { TABLE_PAYOUTS_MICRO_CREDIT } from './tables-micro-credit/payouts.table';
import { TABLE_PURCHASES_MICRO_CREDIT } from './tables-micro-credit/purchases.table';

export enum MERCHANT_TABLES {
  MERCHANTS = 'merchants',
  MERCHANT_PROFILE_PURCHASES = 'merchant-profile-purchases',
  MERCHANT_PROFILE_MOVEMENTS = 'merchant-profile-movements',
  PURCHASES = 'purchases',
  PAYOUTS = 'payouts',
  MOVEMENTS = 'movements',
  MERCHANT_GROUP_MERCHANTS = 'merchant-group-merchants',
}

export const TABLES_BY_PRODUCT_FAMILY: TableFamilyConfig = {
  [DEFAULT_FAMILY]: {
    [MERCHANT_TABLES.MERCHANTS]: TABLE_MERCHANTS_DEFAULT,
    [MERCHANT_TABLES.MERCHANT_PROFILE_PURCHASES]:
      TABLE_MERCHANT_PROFILE_PURCHASES_DEFAULT,
    [MERCHANT_TABLES.MERCHANT_PROFILE_MOVEMENTS]:
      TABLE_MERCHANT_PROFILE_MOVEMENTS_DEFAULT,
    [MERCHANT_TABLES.PURCHASES]: TABLE_PURCHASES_DEFAULT,
    [MERCHANT_TABLES.PAYOUTS]: TABLE_PAYOUTS_DEFAULT,
    [MERCHANT_TABLES.MOVEMENTS]: TABLE_MOVEMENTS_DEFAULT,
    [MERCHANT_TABLES.MERCHANT_GROUP_MERCHANTS]:
      TABLE_MERCHANT_GROUP_MERCHANTS_DEFAULT,
  },
  [PRODUCT_FAMILY.BNPL]: {
    [MERCHANT_TABLES.MERCHANTS]: TABLE_MERCHANTS_BNPL,
    [MERCHANT_TABLES.MERCHANT_PROFILE_PURCHASES]:
      TABLE_MERCHANT_PROFILE_PURCHASES_BNPL,
    [MERCHANT_TABLES.MERCHANT_PROFILE_MOVEMENTS]:
      TABLE_MERCHANT_PROFILE_MOVEMENTS_BNPL,
    [MERCHANT_TABLES.PURCHASES]: TABLE_PURCHASES_BNPL,
    [MERCHANT_TABLES.PAYOUTS]: TABLE_PAYOUTS_BNPL,
    [MERCHANT_TABLES.MOVEMENTS]: TABLE_MOVEMENTS_BNPL,
    [MERCHANT_TABLES.MERCHANT_GROUP_MERCHANTS]:
      TABLE_MERCHANT_GROUP_MERCHANTS_BNPL,
  },
  [PRODUCT_FAMILY.CREDIT_CARD]: {
    [MERCHANT_TABLES.MERCHANTS]: TABLE_MERCHANTS_CREDIT_CARD,
    [MERCHANT_TABLES.MERCHANT_PROFILE_PURCHASES]:
      TABLE_MERCHANT_PROFILE_PURCHASES_CREDIT_CARD,
    [MERCHANT_TABLES.MERCHANT_PROFILE_MOVEMENTS]:
      TABLE_MERCHANT_PROFILE_MOVEMENTS_CREDIT_CARD,
    [MERCHANT_TABLES.PURCHASES]: TABLE_PURCHASES_CREDIT_CARD,
    [MERCHANT_TABLES.PAYOUTS]: TABLE_PAYOUTS_CREDIT_CARD,
    [MERCHANT_TABLES.MOVEMENTS]: TABLE_MOVEMENTS_CREDIT_CARD,
    [MERCHANT_TABLES.MERCHANT_GROUP_MERCHANTS]:
      TABLE_MERCHANT_GROUP_MERCHANTS_CREDIT_CARD,
  },
  [PRODUCT_FAMILY.MCA]: {
    [MERCHANT_TABLES.MERCHANTS]: TABLE_MERCHANTS_MCA,
    [MERCHANT_TABLES.MERCHANT_PROFILE_PURCHASES]:
      TABLE_MERCHANT_PROFILE_PURCHASES_MCA,
    [MERCHANT_TABLES.MERCHANT_PROFILE_MOVEMENTS]:
      TABLE_MERCHANT_PROFILE_MOVEMENTS_MCA,
    [MERCHANT_TABLES.PURCHASES]: TABLE_PURCHASES_MCA,
    [MERCHANT_TABLES.PAYOUTS]: TABLE_PAYOUTS_MCA,
    [MERCHANT_TABLES.MOVEMENTS]: TABLE_MOVEMENTS_MCA,
    [MERCHANT_TABLES.MERCHANT_GROUP_MERCHANTS]:
      TABLE_MERCHANT_GROUP_MERCHANTS_MCA,
  },
  [PRODUCT_FAMILY.MICRO_CREDIT]: {
    [MERCHANT_TABLES.MERCHANTS]: TABLE_MERCHANTS_MICRO_CREDIT,
    [MERCHANT_TABLES.MERCHANT_PROFILE_PURCHASES]:
      TABLE_MERCHANT_PROFILE_PURCHASES_MICRO_CREDIT,
    [MERCHANT_TABLES.MERCHANT_PROFILE_MOVEMENTS]:
      TABLE_MERCHANT_PROFILE_MOVEMENTS_MICRO_CREDIT,
    [MERCHANT_TABLES.PURCHASES]: TABLE_PURCHASES_MICRO_CREDIT,
    [MERCHANT_TABLES.PAYOUTS]: TABLE_PAYOUTS_MICRO_CREDIT,
    [MERCHANT_TABLES.MOVEMENTS]: TABLE_MOVEMENTS_MICRO_CREDIT,
    [MERCHANT_TABLES.MERCHANT_GROUP_MERCHANTS]:
      TABLE_MERCHANT_LIST_NEW_GROUP_MERCHANTS_MICRO_CREDIT,
  },
};

export const getMerchantsTablePerFamily = (
  family: string,
  table: MERCHANT_TABLES
): TableHeader[] => {
  return !!family
    ? TABLES_BY_PRODUCT_FAMILY[family][table]
    : TABLES_BY_PRODUCT_FAMILY[DEFAULT_FAMILY][table];
};
